#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>



int
main(int argc, char **argv)
{
	void (*sh)(); /* urgh - FIXME */
	int i;
	int delay = 3;
	int rc = EXIT_SUCCESS;
	int killsig = SIGUSR1;

	/* Usage: child [delay [return-code [kill-signal]]] */

	if (argc > 1) {
		delay = atoi(argv[1]);
	}
	if (argc > 2) {
		rc = atoi(argv[2]);
	}
	if (argc > 3) {
		killsig = atoi(argv[3]);
	}

	printf("child:");
	for (i = 0; i < argc; i++) {
		printf(" %s", argv[i]);
	}
	printf(" - starting...\n");

	sleep(delay);
	printf("child: initialised\n");

	sh = signal(SIGUSR1, SIG_DFL);
	if (sh == SIG_IGN) {
		pid_t pid;
		pid = getppid();
		if (killsig != 0) {
			printf("child: sending parent a %d\n", killsig);
			kill(pid, killsig);
		}
	}

	printf("child: exit\n");

	return rc;
}
